;
        title     UnRAR Example, Version 3.0.0
; ___________________________________________________
;|                                                   |
;| UnRAR Example, Version 3.0       P. Gene Brennick |
;| pbrennick@charter.net    http://www.pbrennick.com |
;|___________________________________________________|
;|                                                   |
;| Ver. key as follows, UnRAR [De]Compressor a.b.c   |
;|           a:  a major change to the GUI           |
;|           b:  functions added and/or changed      |
;|           c:  bug fixes                           |
;|                                                   |
;| Version History:                                  |
;| ----------------                                  |
;| Original Author:   Florian Mcke, Ver. 2.0.0      |
;| September 9, 2005  Reworked and cleaned up the    |
;|                    code to make it more readable. |
;|                    Configured as a Console App    |
;|                                                   |
;| Current Author:    P. Gene Brennick, Ver. 3.0.0   |
;| April 3, 2006      Major rewrite and convert to   |
;|                    Windows App. First release of  |
;|                    the software. Version tracking |
;|                    starts from this point, on.    |
;|___________________________________________________|
;|                                                   |
        .586      ; Maintain downwards compatibility |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap:none   ; Case Sensitive == 1 |
;|___________________________________________________|
;
;       Include Files
;       ----------------------------------------
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\comctl32.inc 
        include unrar.inc
;
;       Libraries
;       ----------------------------------------
        includelib  \masm32\lib\comctl32.lib 
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  unrar.lib
;
; Prototypes and Data section
; --------------------------------------
WndProc         PROTO :DWORD,:DWORD,:DWORD,:DWORD
ThreadProc      PROTO :DWORD
RARCallbackProc PROTO :DWORD,:DWORD,:DWORD,:DWORD    
;
.data
;---------------------------------------
hInstance       dd  0
hWnd            dd  0
hIcon           dd  0
hArchive        dd  0
ArcName         db  "test.rar", 0
DestPath        db  "EXTRACTED_DATA", 0
caption         db  "W32ASM UNRAR example", 0
ArcOpenErr      db  "archive open error", 0
NextVolQuery    db  "next volume not found", 0
;NextVolOk      db  "next volume successfully opened", 0
ArchiveData     RAROpenArchiveData  <>
HeaderData      RARHeaderData       <>
buffer          db  260 dup (0)
unpSize         dd  0
FormatStr       db  "%lu of %lu bytes", 0
bExtracted      dd  0
fbExtracted     dd  0
dummy_dd        dd  0
FileCRC         dd  0
IDC_PROGRESS    equ 1
ThreadID        dd  0
;
.code
;---------------------------------------
Start:
    invoke  GetModuleHandle, NULL
    mov     hInstance, eax
    invoke  InitCommonControls
    mov     ArchiveData.lpArcName, OFFSET ArcName
    mov     ArchiveData.OpenMode, RAR_OM_LIST
    invoke  RAROpenArchive, ADDR ArchiveData
    mov     hArchive, eax
    .if eax == 0
        invoke  MessageBox, NULL, ADDR ArcOpenErr, ADDR caption, MB_OK
        jmp     the_end
    .endif
;   Get unpacked filesize
    invoke  RARReadHeader, hArchive, ADDR HeaderData
getunpsize:
    invoke  RARProcessFile, hArchive, RAR_SKIP, 0, 0
    mov     eax, HeaderData.UnpSize
    add     unpSize, eax
    invoke  RARReadHeader, hArchive, ADDR HeaderData
    .if eax != ERAR_END_ARCHIVE
        jmp     getunpsize
    .endif
    invoke  RARCloseArchive, hArchive
    invoke  DialogBoxParam, hInstance, 200,0, ADDR WndProc, 0
the_end:
    invoke  ExitProcess, 0
;
;
WndProc proc hWin   :DWORD,
             uMsg   :DWORD,
             wParam :DWORD,
             lParam :DWORD
;---------------------------------------
    .if uMsg == WM_INITDIALOG
        push    hWin
        pop     hWnd
        invoke  LoadIcon, hInstance, 500
        mov     hIcon, eax
        invoke  SendMessage, hWin, WM_SETICON, 1, hIcon
;       mov     eax, 1000
;       shl     eax, 16                 ; Create a high and low word
;       invoke  SendDlgItemMessage, hWin, 1001, PBM_SETRANGE, 0, eax
    .elseif uMsg == WM_COMMAND
        mov     eax, wParam
        .if eax == IDOK                 ; LAUNCH
            invoke  CreateThread, NULL, NULL, ADDR ThreadProc, NULL, NORMAL_PRIORITY_CLASS, ADDR ThreadID
        .elseif eax == IDCANCEL         ; QUIT
            invoke  EndDialog, hWin, 0
        .endif
    .elseif uMsg == WM_CLOSE
        invoke  EndDialog, hWin, 0
    .endif
    xor     eax, eax
    ret
;---------------------------------------
WndProc endp
;
;
ThreadProc PROC RetVal:DWORD
;---------------------------------------
    invoke  SendDlgItemMessage, hWnd, 1002, PBM_SETPOS, eax, 0
    mov     ArchiveData.lpArcName, OFFSET ArcName
    mov     ArchiveData.OpenMode, RAR_OM_EXTRACT
    invoke  RAROpenArchive, ADDR ArchiveData
    mov     hArchive, eax
    invoke  RARSetCallback, hArchive, offset RARCallbackProc, 0
_extract:   
    invoke  RARReadHeader, hArchive, ADDR HeaderData
    .if eax == ERAR_END_ARCHIVE
        jmp     extract_
    .endif
    invoke  SendDlgItemMessage, hWnd, 302, WM_SETTEXT, 0, ADDR HeaderData.ArcName
    invoke  RARProcessFile, hArchive, RAR_EXTRACT, ADDR DestPath, NULL
    jmp     _extract
extract_:
    invoke  RARCloseArchive, hArchive
    ret
;---------------------------------------
ThreadProc endp
;
;
RARCallbackProc PROC msg:DWORD, userData:DWORD, p1:DWORD, p2:DWORD
;---------------------------------------
;   RAR callback proc for data/volume processing
    .if msg == UCM_CHANGEVOLUME
        .if p2 == RAR_VOL_NOTIFY
            invoke  SendDlgItemMessage, hWnd, 302, WM_SETTEXT, 0, p1
            mov     eax, 1
            ret
        .elseif p2 == RAR_VOL_ASK
            invoke  MessageBox, 0, ADDR NextVolQuery, addr caption, MB_OK
            mov     eax, -1
            ret
        .endif
    .elseif msg == UCM_PROCESSDATA
;       .if abort_thread == 1           ; Has thread been aborted?
;           return  -1
;       .endif
;       Check if processing file has changed
        mov     eax, FileCRC
        .if HeaderData.FileCRC != eax   ; New file
            mov     eax, p2             ; n of extracted bytes
            mov     bExtracted, eax
            mov     eax, HeaderData.FileCRC
            mov     FileCRC, eax
            invoke  SendDlgItemMessage, hWnd, 301, WM_SETTEXT, 0, ADDR HeaderData.FileName
        .else                           ; Still on the same file
            mov     eax, p2
            add     bExtracted, eax
        .endif
        .if HeaderData.UnpSize > eax
;           Get percent of current extraction
            finit                       ; Initialize the fpu
            fild    bExtracted          ; Load nBytesExtracted on TOS
            mov     dummy_dd, 100
            fimul   dummy_dd
            fidiv   HeaderData.UnpSize  ; Divides both
            fistp   dummy_dd            ; Get integer from TOS

;           --same without floating point--
;           mov     eax, nBytesExtracted
;           mov     ebx, 100
;           mul     ebx                 ; Result in edx:eax
;           div     HeaderData.UnpSize  ; Source=edx:eax, result in eax
;           mov     dummy_dd, eax
;           ----------------------------

        .else
            mov     eax, 100
            mov     dummy_dd, eax
        .endif
        invoke  SendDlgItemMessage, hWnd, 1001, PBM_SETPOS, dummy_dd, 0
        invoke  wsprintf, ADDR buffer, ADDR FormatStr, bExtracted, HeaderData.UnpSize
        invoke  SendDlgItemMessage, hWnd, 303, WM_SETTEXT, 0, ADDR buffer
;       Get overall progress percentage
        mov     eax, fbExtracted
        add     eax, p2                 ; Add n of extracted bytes
        mov     fbExtracted, eax
        finit                           ; Initialize the fpu
        fld     fbExtracted             ; Load again
        mov     dummy_dd, 100
        fimul   dummy_dd                ; Multiply TOS by 100
        fld     unpSize                 ; Load max extracted size
        fdivp   ST(1), ST(0)            ; Divide to get percentage
        fistp   dummy_dd                ; Save value
        invoke  SendDlgItemMessage, hWnd, 1002, PBM_SETPOS, dummy_dd, 0
        invoke  wsprintf, ADDR buffer, ADDR FormatStr, fbExtracted, unpSize
        invoke  SendDlgItemMessage, hWnd, 304, WM_SETTEXT, 0, ADDR buffer
        mov     eax, 1
        ret
    .elseif msg == UCM_NEEDPASSWORD
;       invoke  lstrcpy, p1, addr pass
    .endif
    xor     eax, eax
    ret
;---------------------------------------
RARCallbackProc ENDP
;
;
    end Start

